/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


#include <libc.h>
#include <stdio.h>

#include "oo7.h"
#include "globals.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "IntBtree.h"
#include "StringBtree.h"

//////////////////////////////////////////////////////////////////
//
// Delete - Delete NumNewCompParts randomly chosen composite parts. 
//
//////////////////////////////////////////////////////////////////


extern int	debugMode;
extern int	nextCompositeId;

//////////////////////////////////////////////////////////////////
//
// Routine to do Delete
//
//////////////////////////////////////////////////////////////////


void delete1()
{
    // now delete the desired number of new composite parts
    int 	compId;
    CompositePart* compH;
    CompositePart* compH2;

    for (int i = 0; i < NumNewCompParts; i++) 
    {
        compId = nextCompositeId++;
        if (debugMode) {
	    printf("In Delete, deleting composite part %d\n", compId);
	}
 printf("In Delete, deleting composite part %d\n", compId);
	compH = (CompositePart*) CompPartIdx->lookup(compId);
	if (compH != NULL) 
	{
	    compH2 = (CompositePart*) CompPartIdx->remove(compId);
	    if (compH2 != compH) 
	       printf("index error in deleting composite part from its idx\n");
	    delete compH;
	}
	else
            fprintf(stderr, "ERROR: Unable to locate composite part %d\n", compId);
    }
}

